<?php

/**
 * autenticar actions.
 *
 * @package    canon
 * @subpackage autenticar
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class autenticarActions extends sfQuery {

    /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            if ($key != 'password') {
                $this->logMessage("request[$key] = $value");
            }
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * variables de filtro
             */
            $username = 'sin usuario';
            $whereUserName = ' ';
            if (isset($request['username'])) {
                $username = $request['username'];
                $whereUserName = " AND tab0.username = '" . $request['username'] . "' ";
            }

            $wherePassword = ' ';
            if (isset($request['password'])) {
                $wherePassword = " AND tab0.password = '" . $request['password'] . "' ";
            }

            // Solo registra log la primera vez de consulta
            if ($rowStart == 0) {
                //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                $id_ope_bd = 1;
                //obtener id maestro tabla
                $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_usuario');
                //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd, "Se produjo una autenticación en el módulo privado para el usuario: " . $username);
            }
            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from(

select 
tab0.id_usuario as autenticacion, tab0.id_usuario, tab0.username, tab0.password, tab0.estado 
                              
from ca_usuario tab0 

  
where tab0.id_usuario != '-1' and tab0.estado=1 
$whereUserName
$wherePassword
    
)tabla
EOD;

            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            //validar si hay registros
            if ($total_record_count > 0) {


                /*
                 * Obtiene el registo de usuario si se encuentra autenticado
                 */
                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
 

select 
tab0.id_usuario as autenticacion, tab0.id_usuario, tab0.username, tab0.password, tab0.estado 
                              
from ca_usuario tab0 

  
where tab0.id_usuario != '-1'  and tab0.estado=1 
$whereUserName
$wherePassword
    
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart 
EOD;


                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);
                $id_usuario = 1;

                /*
                 * Se autentico usuario
                 */
                if ($records[0]["autenticacion"] != null) {
                    $records[0]["autenticacion"] = true;


                    //asignar id del usuario al autenticar

                    $id_usuario = $records[0]["id_usuario"];
                    $records[0]["password"] = base64_encode($records[0]["password"]);
                }


                $this->logMessage("[AUTENTICAR] Autenticado.");

                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowEnd;
                $this->list_data = $records;
                $this->logMessage("[AUTENTICAR] Consulta exitosa.");
            } else {

                $id_usuario = 0;
                $this->logMessage("[AUTENTICAR] No Autenticado");
                $mensaje = "[AUTENTICAR] No hay registros de consulta.";

                $this->totalRows = 1;
                $this->startRow = $rowStart;
                $this->endRow = $rowEnd;

                $records[0]["rownum"] = "1";
                $records[0]["autenticacion"] = false;


                $this->list_data = $records;
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {

            $this->status = 1;
            $this->mensajeError = "ERROR!!!";
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
